import { Observable } from 'rxjs';
import { ThumbAdapter } from '../thumb/thumb-adapter';
import { PointerEventsAdapter } from '../utils/pointer-events-adapter';
import * as i0 from "@angular/core";
export declare abstract class TrackAdapter extends PointerEventsAdapter {
    private sizeChangeSub;
    private currMousePosition;
    private scrollDirection;
    protected scrollMax: number;
    protected abstract readonly cssLengthProperty: string;
    protected abstract get viewportScrollSize(): number;
    protected abstract get viewportSize(): number;
    protected get clientRect(): DOMRect;
    abstract get size(): number;
    abstract get offset(): number;
    protected abstract scrollTo(position: number): Observable<void>;
    protected abstract getScrollDirection(position: number): 'forward' | 'backward';
    protected thumb: ThumbAdapter;
    get pointerEvents(): Observable<PointerEvent>;
    constructor();
    protected abstract getScrollForwardIncrement(): number;
    protected abstract getScrollBackwardIncrement(): number;
    protected abstract getOnGoingScrollForward(): {
        position: number;
        nextPosition: number;
        endPosition: number;
    };
    protected abstract getOnGoingScrollBackward(): {
        position: number;
        nextPosition: number;
        endPosition: number;
    };
    private update;
    /**
     *  Callback when mouse is first clicked on the track
     */
    onTrackFirstClick(e: PointerEvent): Observable<void>;
    /**
     * Callback when mouse is still down on the track
     * Incrementally scrolls towards target position until reached
     */
    onTrackOngoingMousedown(): Observable<boolean>;
    /**
     *  Returns the normalized position whether it's forward or backward for both LTR or RTL directions
     */
    private getCurrPosition;
    /**
     * Returns a flag that determines whether the scroll from the given position is the final step or not
     */
    private isFinalStep;
    static ɵfac: i0.ɵɵFactoryDeclaration<TrackAdapter, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TrackAdapter, never, never, {}, {}, ["thumb"], never, false, never>;
}
