import { WritableSignal } from '@angular/core';
export declare class ViewportAdapter {
    /**
     * Viewport native element
     */
    nativeElement: HTMLElement;
    /**
     * The element that wraps the content inside the viewport,
     * used to measure the content size and observe its changes
     */
    contentWrapperElement: HTMLElement;
    initialized: WritableSignal<boolean>;
    /** Viewport clientHeight */
    get offsetHeight(): number;
    /** Viewport clientWidth */
    get offsetWidth(): number;
    /** Viewport scrollTop */
    get scrollTop(): number;
    /** Viewport scrollLeft */
    get scrollLeft(): number;
    /** Content height, falls back to scroll height */
    get contentHeight(): number;
    /** Content width, falls back to scroll height */
    get contentWidth(): number;
    /** The horizontal remaining scrollable distance */
    get scrollMaxX(): number;
    /** The vertical remaining scrollable distance */
    get scrollMaxY(): number;
    /**
     * Initialize viewport
     */
    init(viewportElement: HTMLElement, contentElement: HTMLElement, spacerElement?: HTMLElement): void;
    /**
     * Scroll viewport vertically
     */
    scrollYTo(value: number): void;
    /**
     * Scroll viewport horizontally
     */
    scrollXTo(value: number): void;
}
